#Compiler PBWin 10
#Compile Exe "gbsand.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode = 1
#Include "cwindow.inc"
#Include "files\gbOnlineUpdate.inc"
#Include "cgdiplus.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "icons\gbsand.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xbarriers "icons\barriers.ico"
#Resource Icon xxprint "icons\print.ico"
#Resource Icon xcompact "icons\compact.ico"
#Resource Icon xcopy "icons\copy.ico"
#Resource Icon xerase "icons\object.ico"
#Resource Icon xdraw "icons\draw.ico"
#Resource Icon xrestart "icons\restart.ico"
#Resource Icon xplay "icons\play.ico"
#Resource Icon xsound "icons\sound.ico"
#Resource Icon xplus "icons\plus.ico"
#Resource Icon xminus "icons\minus.ico"
#Resource Icon xzoom "icons\zoom.ico"
#Resource Icon xspout "icons\spout.ico"
#Resource Icon xcutb "icons\erase_barriers.ico"
#Resource Icon xcutp "icons\erase_particles.ico"
#Resource Icon xcuti "icons\erase_imports.ico"
#Resource Icon xopen, "icons\open.ico"
#Resource Icon xsave, "icons\save.ico"
#Resource Icon xfolder, "icons\folder.ico"
#Resource Icon xcut, "icons\cut.ico"
#Resource Icon ximage, "icons\image.ico"
#Resource Icon xleft, "icons\arrowleft.ico"
#Resource Icon xright, "icons\arrowright.ico"
#Resource Icon xselect, "icons\select.ico"

#Resource Icon xsand, "icons\sand.ico"
#Resource Icon xoil, "icons\oil.ico"
#Resource Icon xwater, "icons\water.ico"
#Resource Icon xseed, "icons\seed.ico"
#Resource Icon xfire, "icons\fire.ico"
#Resource Icon xsalt, "icons\salt.ico"
#Resource Icon xlaser, "icons\laser.ico"
#Resource Icon xcloud, "icons\cloud.ico"
#Resource Icon xvirus, "icons\virus.ico"

#Resource Icon aaa, "icons\download.ico"   'user-supplied icon, representing the main EXE. must be 48x48.

#Resource RcData, xcurdraw, "icons\draw.cur"
#Resource RcData, xcurerase, "icons\erase.cur"
#Resource RcData, xcurspout, "icons\spout.cur"
#Resource RcData, xcurimage, "icons\image.cur"
#Resource RcData, xcurselect,"icons\select.cur"

#Resource Wave,   xwavdraw, "files\draw.wav"
#Resource Wave,   xwavspout, "files\spout.wav"
#Resource Wave,   xwavimage, "files\import.wav"
#Resource Wave,   xwaveraseb, "files\erase_barriers.wav"
#Resource Wave,   xwaverasep, "files\erase_particles.wav"
#Resource Wave,   xwaverasei, "files\erase_imports.wav"
#Resource Wave,   xwaverasea, "files\erase_all.wav"

$Ver = "5.2"

$SessionFile        = "files\session.gam"
$EraseBarriersFile  = "files\erase_barriers.wav"
$EraseParticlesFile = "files\erase_particles.wav"
$EraseImportsFile   = "files\erase_imports.wav"
$EraseAllFile       = "files\erase_all.wav"
$DrawFile           = "files\draw.wav"
$SpoutFile          = "files\spout.wav"
$ImageFile          = "files\image.wav"

$tempCursorFile  = "files\tempcursor.cur"

$curDrawBarriers = "icons\draw.cur"
$curCutAll       = "icons\erase.cur"
$curCutBarriers  = "icons\erase.cur"
$curCutParticles = "icons\erase.cur"
$curCutImports   = "icons\erase.cur"
$curSpout        = "icons\spout.cur"
$curSelect       = "icons\select.cur"

%ID_Timer   = 500
%ID_Graphic = 600

Type ParticleType
   x As Long
   y As Long
   bgrcolor As Long
   vx As Long
   vy As Long
   m As Long
   type As Long
   tbd1 As Long
   tbd2 As Long
   title As String * 20
End Type

Type BarrierType
   x1 As Long
   x2 As Long
   y1 As Long
   y2 As Long
   tbd1 As Long
   tbd2 As Long
   title As String * 20
End Type

Type StreamType
   x1 As Long
   x2 As Long
   y As Long
   bgrcolor As Long
   type As Long   'particle types
   tbd1 As Long
   tbd2 As Long
   title As String * 20
End Type

Enum Equates Singular
   IDC_Toolbar  = 500
   IDC_ToolbarB
   IDC_ToolbarC
   IDC_Graphic
   IDC_Gallery
   IDC_Scrollbar

   IDT_Settings
   IDT_OpenGame
   IDT_SaveGame
   IDT_Play
   IDT_Restart
   IDT_Plus
   IDT_Minus
   IDT_Zoom
   IDT_Sound
   IDT_Print
   IDT_DrawBarrier
   IDT_Select
   IDT_CutAll
   IDT_CutBarriers
   IDT_CutParticles
   IDT_CutImports
   IDT_Sand
   IDT_Oil
   IDT_Water
   IDT_Seed
   IDT_Fire
   IDT_Salt
   IDT_Laser
   IDT_Cloud
   IDT_Virus
   IDT_SepA
   IDT_SepB
   IDT_SepC
   IDT_Help

   IDM_Sep
   IDM_ShowStatus
   IDM_Compact
   IDM_RemoveAllParticles

   IDM_AddDefaultBarriers
   IDM_RemoveMRBarrier
   IDM_RemoveAllBarriers

   IDM_AddDefaultStreams
   IDM_RemoveMRStream
   IDM_RemoveAllStreams

   IDM_Information

   IDM_Font
   IDM_Color
   IDM_DrawWidth
   IDM_EraseWidth
   IDM_PMax
   IDM_Zoom
   IDM_Test
   IDM_AllowMixing
   IDM_ImportScaleFactor

   IDM_StartEmpty
   IDM_CustomCursors
   IDM_AutoSave
   IDM_OnlineUpdate
   IDM_AskConfirmation
   IDM_Landscape
   IDM_Capture
   IDM_BigErase
   IDM_LocalHelp
   IDM_DrawBarrier
   IDM_CutAll
   IDM_CutBarriers
   IDM_CutParticles
   IDM_ImportSize100
   IDM_SpoutCloud
   IDM_FullCount

   IDM_SCancel
   IDM_SCopy
   IDM_SEraseAll
   IDM_SEraseBarriers
   IDM_SEraseParticles
   IDM_SEraseImports

   IDM_Sand
   IDM_Oil
   IDM_Water
   IDM_Seed
   IDM_Fire
   IDM_Salt
   IDM_Laser
   IDM_Cloud
   IDM_Virus

   IDM_Debug

   Cut    = 800   'ActionMode
   Draw           'ActionMode
   Spout          'ActionMode
   Import         'ActionMode
   Select         'ActionMode

   IDM_GameMenu  = 1000    'filled with content of \games
   IDM_ImageMenu = 2000    'filled with content of \images

   IDT_ButtonC   = 3000
End Enum

%Sand    = 0   'SpoutType
%Oil     = 1   'SpoutType
%Water   = 2   'SpoutType
%Seed    = 3   'SpoutType
%Fire    = 4   'SpoutType
%Salt    = 5   'SpoutType
%Laser   = 6   'SpoutType
%Cloud   = 7   'SpoutType
%Virus   = 8   'SpoutType

%CutAll       = 0  'CutType
%CutBarriers  = 1  'CutType
%CutParticles = 2  'CutType
%CutImports   = 3  'CutType

%Barrier = 0   'DrawType
%Wheel   = 1   'DrawType
%Drifter = 2   'DrawType

%IsDeadParticle     = -1  'Particle is dead

%IsBarrierCell      =  0  'Content of Cell
%IsImportCell       = -1  'Content of Cell
%IsEmptyCell        = -2  'Content of Cell

Type CustomColors
   c(15) As Long
End Type

Global hDlg,hContext,hSettings,hPrint,hSelect, hToolbar,ghHook As Dword
Global hFont,hHelp,hImageList,hImageListC,hGames,hBMP,hTxtWin As Dword
Global P() As ParticleType, bmp$
Global PF(),C(),pCount, Delta, FontSize, FontAttr, CustomCursors, SpoutType,CutType,DrawType As Long
Global qFreq, qStart, qStop, qGameStart As Quad
Global ContextInWork, AutoSave,PMax,PenWidth, DrawWidth,EraseWidth As Long
Global CustomColorList As CustomColors, PTMenu As Point, AskConfirmation, Landscape As Long
Global FontName, FileName,ImageName,CutName,DrawName As WStringZ * %Max_Path, SpoutColors() As Long
Global SpoutText(), ImportText() As String, hToolbarB, hToolbarC As Dword
Global Barriers() As BarrierType, Streams() As StreamType, BW,BMax, HalfSize, ImportSize As Long
Global BGRBarrierColor, BGColor, BGRBGColor, ShowStatus, GameSpeed, TimerInterval, pLiveCount As Long
Global PlaySounds, ActionMode,PlayGame, LastX,LastY, TBM As Long   'TBM is Toolbar Margin
Global hDrawBarriers, hCutAll, hCutBarriers, hCutParticles, hCursorSelect, hCursorSpout,hCursorImage As Dword
Global SandColor, OilColor, WaterColor, SeedColor, FireColor As Long
Global SaltColor, LaserColor, CloudColor, VirusColor, StartEmpty, ShowSelectContext As Long
Global BGRSandColor, BGROilColor, BGRWaterColor, BGRSeedColor, BGRFireColor As Long
Global BGRSaltColor, BGRLaserColor, BGRCloudColor, BGRVirusColor As Long, RG, R,R2 As Rect
Global SpoutCloud, BSelection, CSelection, AllowMixing, FullCount,Debug As Long
Function PBMain() As Long
   Local sw,sh As Long
   sw = GetSystemMetrics(%SM_CXVirtualScreen)
   sh = GetSystemMetrics( %SM_CYVirtualScreen)
   Dialog New Pixels, 0, "Falling Sand v" + $Ver,,,400,200, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"

   Control Add Graphic, hDlg, %IDC_Graphic, "", 0,200,sw,sh
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Clear BGColor
   Graphic Get Bits To bmp$

   Control Add ScrollBar, hDlg, %IDC_Scrollbar, "", 0,160,100,20
   Dialog Show Modal hDlg Call DlgProc
   If RestartUpdate Then RestartUpdatedEXE
End Function

CallBack Function DlgProc() As Long
   Local w,h,iResult,x,y,i,OldBGRBGColor As Long, temp$
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr, rc As Rect, pt As Point

   Select Case Cb.Msg
      Case %WM_InitDialog
         GetDebug
         QueryPerformanceFrequency qFreq
         Randomize Timer
         hUpdateParent = hDlg
         LastX = -1 : BW = 31 : Delta = 1 : TimerInterval = 100
         Font New FontName, FontSize, FontAttr To hFont  'used by Toolbar
         BuildAcceleratorTable
         LoadCursors
         CreateSubFolders
         CreateToolbarStructures
         CreateContextMenus
         Settings_INI "get"
         BuildSpoutColors
         TBM = 180
         Control Set Loc hDlg, %IDC_Graphic, 0,TBM
         CreateToolbar
         CreateToolbarB
         CreateToolbarC
         ScrollBar Set Pagesize hDlg, %IDC_Scrollbar, 25
         ScrollBar Set Pos hDlg, %IDC_Scrollbar, 1
         ScrollBar Set Range hDlg, %IDC_Scrollbar, 1, BW*BMax
         SetMenusAndToolbar
         If IsFile($SessionFile) Then
            LoadGame($SessionFile)
         Else
            ClearScreen
            If StartEmpty = 0 Then AddDefaultBarriers : AddDefaultStreams : DisplayAllBarriers
         End If
         QueryPerformanceCounter qGameStart
         SetTimer(hDlg, %ID_Timer, TimerInterval, 0)
      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         If IsFile($SessionFile) Then Kill $SessionFile
         If AutoSave Then SaveGame($SessionFile)
         Settings_INI "save"
      Case %WM_Timer
         If PlayGame Then
            For i = 1 To GameSpeed
               QueryPerformanceCounter   qStart
               MoveParticles
               AddParticles
               QueryPerformanceCounter   qStop
               UpdateCaption
            Next i
         End If
         Graphic Set Bits bmp$
         Graphic ReDraw

      Case %WM_HScroll
         Dialog Get Client hDlg To w,h
         ScrollBar Get Pos hDlg, %IDC_ScrollBar To iResult
         Select Case Lo(Word, Cb.WParam)
            Case %SB_LineLeft   : iResult -= BW
            Case %SB_PageLeft   : iResult -= 5*BW
            Case %SB_LineRight  : iResult += BW
            Case %SB_PageRight  : iResult += 5*BW
            Case %SB_ThumbTrack : iResult=Hi(Word, Cb.WParam)
         End Select
         ScrollBar Set Pos hDlg, %IDC_Scrollbar, iResult
         Control Set Loc hDlg, %IDC_ToolbarC, -iResult,120

      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_Scrollbar, w,20
         ScrollBar Set Range hDlg, %IDC_Scrollbar, 1, BW*(BMax+1)-w

      Case %WM_ContextMenu
         ContextInWork = 1
         PTMenu.X = Lo(Integer,Cb.LParam) : PTMenu.Y = Hi(Integer, Cb.LParam)
         TrackPopupMenu hContext, %TPM_LeftAlign, PTMenu.X, PTMenu.Y, 0, Cb.Hndl, ByVal 0

      Case %WM_SetCursor
         If CustomCursors Then
            GetCursorPos pt    'p.x and p.y are in screen coordinates
            ScreenToClient hDlg, pt  'p.x and p.y are now dialog client coordinates
            If ChildWindowFromPoint(hDlg,pt) = GetDlgItem(hDlg, %IDC_Graphic) Then
               Select Case ActionMode
                  Case %Select : MousePtr hCursorSelect
                  Case %Cut    : MousePtr hCutAll
                  Case %Draw   : MousePtr hDrawBarriers
                  Case %Spout  : MousePtr hCursorSpout
                  Case %Import : MousePtr hCursorImage
               End Select
               Function = 1
            End If
         End If

      Case %WM_LButtonDblClk
         If ActionMode = %Spout Then
            'returns client coordinates
            x = Lo(Integer,Cb.LParam)
            y = Hi(Integer,Cb.LParam)
            i = UBound(Streams)
            ReDim Preserve Streams(i+1)
            Streams(i+1).x1 = x
            Streams(i+1).x2 = x+6
            Streams(i+1).y = y-TBM
            Streams(i+1).type = SpoutType
            Streams(i+1).bgrcolor = SpoutColors(SpoutType)
            If PlaySounds Then PlaySound "xwavspout", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
         ElseIf ActionMode = %Import Then
            'returns client coordinates
            x = Lo(Integer,Cb.LParam)
            y = Hi(Integer,Cb.LParam)
            ImportImage((ImageName),x,y)
            If PlaySounds Then PlaySound "xwavimage", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
         End If

      Case %WM_LButtonDown
         SetCapture hDlg    'start capturing, so can detect LButtonUp when it occurs
         If PlaySounds Then PlaySound "", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
         If ActionMode = %Select Then
            ShowSelectContext = 0
            R.nLeft = Lo(Word, Cb.LParam)   : R.nTop  = Hi(Word, Cb.LParam)
         End If

      Case %WM_MouseMove
         If GetCapture() = hDlg Then
            If ContextInWork  Then
               ContextInWork = 0
            Else
               If ActionMode = %Select Then
                  Incr ShowSelectContext
                  If ShowSelectContext = 1 Then KillTimer hDlg, %ID_Timer
                  R.nRight  = Lo(Word, Cb.LParam) : R.nBottom = Hi(Word, Cb.LParam)
                  If (Cb.WParam And %MK_LBUTTON) Then DrawRect 1
               Else
                  'returns client coordinates
                  x = Lo(Integer,Cb.LParam)
                  y = Hi(Integer,Cb.LParam)
                  If x > 0 And y > TBM+PenWidth/2+1 Then CutOrDraw x,y,Cb.WParam
               End If
            End If
         End If
      Case %WM_LButtonUp
         ReleaseCapture
         LastX = -1
         If (ActionMode = %Select) And ShowSelectContext Then
            ContextInWork = 1
            PTMenu.X = Lo(Integer,Cb.LParam) : PTMenu.Y = Hi(Integer, Cb.LParam)
            ClientToScreen(hDlg, PTMenu)
            TrackPopupMenu hSelect, %TPM_LeftAlign, PTMenu.X, PTMenu.Y, 0, Cb.Hndl, ByVal 0
            DrawRect 0
            SetTimer(hDlg, %ID_Timer, TimerInterval, 0)
         End If

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                 Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                 Select Case @nmtb.iItem
                    Case %IDT_OpenGame
                       CreateGameMenu
                       Call TrackPopupMenu (hGames, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Print
                       Call TrackPopupMenu (hPrint, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Settings
                       Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Help
                       Call TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Settings To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         PTT = Cb.LParam
                         @PTT.@lpszText = SetToolTips(Cb.NmId)
                  End Select
           End Select
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_SaveGame
               iResult = PlayGame
               PlayGame = 0        'Pause while saving
               SaveAsGame
               PlayGame = iResult  'restore game to prior PlayGame status
            Case %IDT_OpenGame
               iResult = PlayGame
               PlayGame = 0        'Pause while opening new game
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  Select Case MessageBox(0, "Save current game before opening new game?", "Open Game", %MB_YesNoCancel + %MB_IconQuestion)
                     Case %IdYes   : SaveAsGame : SelectAndLoadGame
                     Case %IdNo    : SelectAndLoadGame
                     Case %IdCancel : 'take no action
                  End Select
                  UnhookWindowsHookEx ghHook
               Else
                  SelectAndLoadGame
               End If
               PlayGame = iResult  'restore game to prior PlayGame status

            Case %IDT_Play
               PlayGame = PlayGame Xor 1
               SetMenusAndToolbar
            Case %IDT_Restart
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  If MessageBox(0, "Restart Game? All content will be lost!", "Restart Game", %MB_OkCancel + %MB_IconQuestion) = %IdOk Then RestartGame
                  UnhookWindowsHookEx ghHook
               Else
                  RestartGame
               End If

            Case %IDT_Plus  : GameSpeed = GameSpeed + 1
            Case %IDT_Minus : GameSpeed = Max(1,GameSpeed-1)

            Case %IDT_Zoom
               Select Case ImportSize
                  Case 25    : ImportSize = 50
                  Case 50    : ImportSize = 75
                  Case 75    : ImportSize = 100
                  Case 100   : ImportSize = 150
                  Case 150   : ImportSize = 200
                  Case Else  : ImportSize = 25
               End Select
               RebuildZoom

            Case %IDT_Sound
               PlaySounds = PlaySounds Xor 1

            Case %IDT_Print
               PrintGame

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbsand.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_ButtonC To %IDT_ButtonC+999
               ActionMode = %Import
               CSelection = Cb.Ctl
               BSelection = -Abs(BSelection)
               ImageName = ImportText(Cb.Ctl - %IDT_ButtonC)
               SetMenusAndToolbar

            Case %IDM_Test
               For w = 1 To 30
                  temp$ = temp$ + $CrLf + Str$(P(w).x) + Str$(P(w).y)
               Next W
               ? temp$

            Case %IDM_FullCount
               FullCount = FullCount Xor 1 : Beep
               SetMenusAndToolbar

            Case %IDM_AllowMixing
               AllowMixing = AllowMixing Xor 1 : Beep
               SetMenusAndToolbar

            Case %IDM_BigErase
               If EraseWidth = 10 Then
                  EraseWidth = 50
                  ReadText "Size 50"
               Else
                  EraseWidth = 10
                  ReadText "Size 10"
               End If

            Case %IDM_Capture  :  keybd_event(%VK_SnapShot, 1, 0, 0)  'place active dialog on clipboard

            Case %IDT_Select       : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : ActionMode = %Select : SetMenusAndtoolbar : PenWidth = 1
            Case %IDT_DrawBarrier  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : DrawType = %Barrier     : DrawName = "Barriers" : ActionMode = %Draw : SetMenusAndtoolbar : PenWidth = DrawWidth

            Case %IDT_CutAll       : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : CutType = %CutAll       : CutName = "     All     " : ActionMode = %Cut : SetMenusAndToolbar : PenWidth = EraseWidth
            Case %IDT_CutBarriers  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : CutType = %CutBarriers  : CutName = "Barriers"      : ActionMode = %Cut : SetMenusAndToolbar : PenWidth = EraseWidth
            Case %IDT_CutParticles : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : CutType = %CutParticles : CutName = "Particles"     : ActionMode = %Cut : SetMenusAndToolbar : PenWidth = EraseWidth
            Case %IDT_CutImports   : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : CutType = %CutImports   : CutName = "Imports"       : ActionMode = %Cut : SetMenusAndToolbar : PenWidth = EraseWidth

            Case %IDT_Sand  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Sand  : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Oil   : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Oil   : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Water : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Water : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Seed  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Seed  : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Fire  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Fire  : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Salt  : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Salt  : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Laser : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Laser : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Cloud : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Cloud : ActionMode = %Spout : SetMenusAndToolbar
            Case %IDT_Virus : BSelection = Cb.Ctl : CSelection = -Abs(CSelection) : SpoutType = %Virus : ActionMode = %Spout : SetMenusAndToolbar

            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  Txt.Window "Debug", 300,300,40,40 To hTxtWin
               Else
                  Txt.End
               End If

            Case %IDM_SCancel   'no action
            Case %IDM_SCopy           : CopySelection
            Case %IDM_SEraseAll       : CutType = %CutAll       : CutSelection : SetMenusAndToolbar
            Case %IDM_SEraseBarriers  : CutType = %CutBarriers  : CutSelection : SetMenusAndToolbar
            Case %IDM_SEraseParticles : CutType = %CutParticles : CutSelection : SetMenusAndToolbar
            Case %IDM_SEraseImports   : CutType = %CutImports   : CutSelection : SetMenusAndToolbar

            Case %IDM_Information
               ? "PMax" + $Tab + $Tab + Str$(PMax) + $CrLf + _
                 "PCount" + $Tab + $Tab + Str$(PCount) + $CrLf + _
                 "AskConfirmation" + $Tab + Str$(AskConfirmation) + $CrLf + _
                 "Draw Width" + $Tab + $Tab + Str$(DrawWidth) + $CrLf + _
                 "Erase Width" + $Tab + $Tab + Str$(EraseWidth) + $CrLf + _
                 "Custom Cursors" + $Tab + Str$(CustomCursors) + $CrLf + _
                 "GameSpeed" + $Tab + Str$(GameSpeed) + $CrLf + _
                 "AutoSave" + $Tab + $Tab + Str$(AutoSave) + $CrLf + _
                 "Allow Mixing" + $Tab + $Tab + Str$(AllowMixing) + $CrLf + _
                 "Detailled Caption" + $Tab + $Tab + Str$(FulLCount) + $CrLf + _
                 "ActionMode" + $Tab + Switch$(ActionMode=%Draw,"Draw",ActionMode=%Cut,"Cut",ActionMode=%Spout,"Spout")

            Case %IDM_ShowStatus, %IDT_Settings
               ShowStatus = ShowStatus Xor 1
               If ShowStatus = 0 Then Dialog Set Text hDlg, "Falling Sand v" + $ver
               SetMenusAndToolbar

            Case %IDM_ImportSize100
               ImportSize = 100
               RebuildZoom

            Case %IDM_Font
               SelectMainFont

            Case %IDM_CustomCursors
               CustomCursors = CustomCursors Xor 1
               SetMenusAndToolbar

            Case %IDM_AutoSave
               AutoSave = AutoSave Xor 1
               SetMenusAndToolbar

            Case %IDM_AskConfirmation
               AskConfirmation = AskConfirmation Xor 1
               SetMenusAndToolbar

            Case %IDM_Landscape
               Landscape = Landscape Xor 1
               SetMenusAndToolbar

            Case %IDM_ImportScaleFactor
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter import scale factor:", "Import Scale Factor", Str$(ImportSize),w+40,h+150)
               If Len(temp$) Then ImportSize = Max(1,Val(temp$))
               UnhookWindowsHookEx ghHook

            Case %IDM_StartEmpty
               StartEmpty = StartEmpty Xor 1
               SetMenusAndToolbar

            Case %IDM_SpoutCloud
               SpoutCloud = SpoutCloud Xor 1
               SetMenusAndToolbar

            Case %IDM_PMax
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter maximum point count:", "Maximum Points", Str$(PMax),w+40,h+150)
               If Len(temp$) Then
                  PMax = Val(temp$)
                  ReDim Preserve P(PMax)
               End If
               UnhookWindowsHookEx ghHook

            Case %IDM_DrawWidth
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter draw width in pixels:", "Draw Width", Str$(DrawWidth),w+40,h+150)
               If Len(temp$) Then DrawWidth = Val(temp$) : DrawWidth = Max(DrawWidth,1) : PenWidth = DrawWidth
               UnhookWindowsHookEx ghHook

            Case %IDM_EraseWidth
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter erease width in pixels:", "Erase Width", Str$(EraseWidth),w+40,h+150)
               If Len(temp$) Then EraseWidth = Val(temp$) : EraseWidth = Max(EraseWidth,1) : PenWidth = EraseWidth
               UnhookWindowsHookEx ghHook

            Case %IDM_Color
               OldBGRBGColor = BGRBGColor
               iResult = SelectColor(BGColor)
               If iResult <> BGColor Then
                  BGColor = iResult : BGRBGColor = Bgr(iResult)
                  Control Get Size hDlg, %IDC_Graphic To w,h
                  For x = 0 To w-1
                     For y = 0 To h-1
                        If C(x,y) = OldBGRBGColor Then C(x,y) = BGRBGColor
                     Next y
                  Next x
               End If

            Case %IDM_Zoom
               ZoomAtMouse

            Case %IDM_RemoveAllParticles
               RemoveAllParticles

            Case %IDM_Compact
               CompactParticles

            Case %IDM_AddDefaultBarriers  : AddDefaultBarriers   : DisplayAllBarriers
            Case %IDM_RemoveMRBarrier     : RemoveAllBarriers(0) : RemoveMRBarrier      : DisplayAllBarriers
            Case %IDM_RemoveAllBarriers   : RemoveAllBarriers(1)

            Case %IDM_AddDefaultStreams   : AddDefaultStreams
            Case %IDM_RemoveMRStream      : RemoveMRStream
            Case %IDM_RemoveAllStreams    : RemoveAllStreams

            Case %IDM_OnlineUpdate        : CheckForEXEUpDates($ver)
            Case %IDM_LocalHelp           : DisplayLocalHelp

            Case %IDM_GameMenu To %IDM_GameMenu+999
               Menu Get Text hGames, ByCmd Cb.Ctl To temp$
               iResult = PlayGame
               PlayGame = 0        'Pause while opening new game
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  Select Case MessageBox(0, "Save current game before opening new game?", "Open Game", %MB_YesNoCancel + %MB_IconQuestion)
                     Case %IdYes
                        SaveAsGame
                        FileName = Exe.Path$ + "games\" + temp$
                        LoadGame((FileName))
                     Case %IdNo
                        FileName = Exe.Path$ + "games\" + temp$
                        LoadGame((FileName))
                     Case %IdCancel : 'take no action
                  End Select
                  UnhookWindowsHookEx ghHook
               Else
                  FileName = Exe.Path$ + "games\" + temp$ : LoadGame((FileName))
               End If
               PlayGame = iResult  'restore game to prior PlayGame status
         End Select
   End Select
End Function

Sub DisplayAllBarriers
   If Debug Then Txt.Print FuncName$
   Local i,x,y,oldPlayGame As Long
   'create rectangular Barriers
   oldPlayGame = PlayGame
   PlayGame = 0
   For i = 1 To UBound(Barriers)
      For x = Barriers(i).x1 To Barriers(i).x2
         For y = Barriers(i).y1 To Barriers(i).y2
            If PF(x,y) > 0 Then P(PF(x,y)).x = %IsDeadParticle
            C(x,y) = BGRBarrierColor
            PF(x,y) = %IsBarrierCell
         Next y
      Next x
   Next i
   PlayGame = oldPlayGame
End Sub

Sub AddParticles
'   If Debug Then Txt.Print FuncName$  '<--- disabled by choice
   Local i,x,y,w,h As Long
   Dialog Get Client hDlg To w,h
   'add falling particles at top of screen
   For i = 1 To UBound(Streams)
      For x = Streams(i).x1 To Streams(i).x2
         If Rnd(0,1) And (PF(x,Streams(i).y) = %IsEmptyCell) And (PF(x,Streams(i).y+1) = %IsEmptyCell) Then
            If pCount >= UBound(P) Then CompactParticles
            Incr pCount
            P(pCount).x = x  : P(pCount).y = Streams(i).y
            P(pCount).type     = Streams(i).type
            P(pCount).bgrcolor = Streams(i).bgrcolor
            C(x,Streams(i).y)  = Streams(i).bgrcolor
            PF(x,Streams(i).y) = pCount
         Else
            C(x,Streams(i).y) = BGRBGColor
            PF(x,Streams(i).y) = %IsEmptyCell  'empty
         End If
      Next x
   Next i
End Sub

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "680", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "600", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ImageName", "Soldier", ImageName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CutName", "All", CutName, %Max_Path, INIFileName
         If CutName = "All" Then CutName = "     All     "
      Getprivateprofilestring "All", "DrawName", "Barrier", DrawName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "BGColor", "0", temp, %Max_Path, INIFileName: BGColor = Val(temp)
      Getprivateprofilestring "All", "BGRBGColor", "0", temp, %Max_Path, INIFileName: BGRBGColor = Val(temp)
      Getprivateprofilestring "All", "ShowStatus", "0", temp, %Max_Path, INIFileName: ShowStatus = Val(temp)
      Getprivateprofilestring "All", "PlaySounds", "1", temp, %Max_Path, INIFileName: PlaySounds = Val(temp)
      Getprivateprofilestring "All", "ActionMode", Str$(%Draw), temp, %Max_Path, INIFileName: ActionMode = Val(temp)
      Getprivateprofilestring "All", "PlayGame", "1", temp, %Max_Path, INIFileName: PlayGame = Val(temp)
      Getprivateprofilestring "All", "BGRBarrierColor", Str$(Bgr(%Blue)), temp, %Max_Path, INIFileName: BGRBarrierColor = Val(temp)
      Getprivateprofilestring "All", "GameSpeed", "1", temp, %Max_Path, INIFileName: GameSpeed = Val(temp)
      Getprivateprofilestring "All", "TimerInterval", "25", temp, %Max_Path, INIFileName: TimerInterval = Val(temp)
      Getprivateprofilestring "All", "CustomCursors", "1", temp, %Max_Path, INIFileName: CustomCursors = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName: AutoSave = Val(temp)
      Getprivateprofilestring "All", "AskConfirmation", "1", temp, %Max_Path, INIFileName: AskConfirmation = Val(temp)
      Getprivateprofilestring "All", "Landscape", "1", temp, %Max_Path, INIFileName: Landscape = Val(temp)
      Getprivateprofilestring "All", "PMax", "1000000", temp, %Max_Path, INIFileName: PMax = Val(temp)
      Getprivateprofilestring "All", "PenWidth", "10", temp, %Max_Path, INIFileName: PenWidth = Val(temp)
      Getprivateprofilestring "All", "DrawWidth", "10", temp, %Max_Path, INIFileName: DrawWidth = Val(temp)
      Getprivateprofilestring "All", "EraseWidth", "50", temp, %Max_Path, INIFileName: EraseWidth = Val(temp)
      Getprivateprofilestring "All", "SpoutType", Str$(%Sand), temp, %Max_Path, INIFileName: SpoutType = Val(temp)
      Getprivateprofilestring "All", "SpoutCloud", "0", temp, %Max_Path, INIFileName: SpoutCloud = Val(temp)
      Getprivateprofilestring "All", "HalfSize", "1", temp, %Max_Path, INIFileName: HalfSize = Val(temp)
      Getprivateprofilestring "All", "BSelection", Str$(%IDT_DrawBarrier), temp, %Max_Path, INIFileName: BSelection = Val(temp)
      Getprivateprofilestring "All", "CSelection", "0", temp, %Max_Path, INIFileName: CSelection = Val(temp)
      Getprivateprofilestring "All", "StartEmpty", "0", temp, %Max_Path, INIFileName: StartEmpty = Val(temp)
      Getprivateprofilestring "All", "ImportSize", "100", temp, %Max_Path, INIFileName: ImportSize = Val(temp)
      Getprivateprofilestring "All", "AllowMixing", "1", temp, %Max_Path, INIFileName: AllowMixing = Val(temp)
      Getprivateprofilestring "All", "FullCount", "1", temp, %Max_Path, INIFileName: FullCount = Val(temp)

      Getprivateprofilestring "All", "SandColor", Str$(%rgb_Tan), temp, %Max_Path, INIFileName: SandColor = Val(temp)
      Getprivateprofilestring "All", "OilColor", Str$(%Gray), temp, %Max_Path, INIFileName: OilColor = Val(temp)
      Getprivateprofilestring "All", "WaterColor", Str$(%rgb_SkyBlue), temp, %Max_Path, INIFileName: WaterColor = Val(temp)
      Getprivateprofilestring "All", "SeedColor", Str$(%Green), temp, %Max_Path, INIFileName: SeedColor = Val(temp)
      Getprivateprofilestring "All", "FireColor", Str$(%Red), temp, %Max_Path, INIFileName: FireColor = Val(temp)
      Getprivateprofilestring "All", "SaltColor", Str$(%White), temp, %Max_Path, INIFileName: SaltColor = Val(temp)
      Getprivateprofilestring "All", "LaserColor", Str$(%rgb_Magenta), temp, %Max_Path, INIFileName: LaserColor = Val(temp)
      Getprivateprofilestring "All", "CloudColor", Str$(%rgb_Moccasin), temp, %Max_Path, INIFileName: CloudColor = Val(temp)
      Getprivateprofilestring "All", "VirusColor", Str$(%rgb_Purple), temp, %Max_Path, INIFileName: VirusColor = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "ImageName",ImageName, INIFileName
      WritePrivateProfileString "All", "CutName",CutName, INIFileName
      WritePrivateProfileString "All", "DrawName",DrawName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "BGRBGColor", Str$(BGRBGColor), INIFileName
      WritePrivateProfileString "All", "ShowStatus",Str$(ShowStatus), INIFileName
      WritePrivateProfileString "All", "PlaySounds",Str$(PlaySounds), INIFileName
      WritePrivateProfileString "All", "ActionMode",Str$(ActionMode), INIFileName
      WritePrivateProfileString "All", "PlayGame",Str$(PlayGame), INIFileName
      WritePrivateProfileString "All", "BGRBarrierColor",Str$(BGRBarrierColor), INIFileName
      WritePrivateProfileString "All", "GameSpeed",Str$(GameSpeed), INIFileName
      WritePrivateProfileString "All", "TimerInterval",Str$(TimerInterval), INIFileName
      WritePrivateProfileString "All", "CustomCursors",Str$(CustomCursors), INIFileName
      WritePrivateProfileString "All", "AutoSave",Str$(AutoSave), INIFileName
      WritePrivateProfileString "All", "AskConfirmation",Str$(AskConfirmation), INIFileName
      WritePrivateProfileString "All", "Landscape",Str$(Landscape), INIFileName
      WritePrivateProfileString "All", "PMax",Str$(PMax), INIFileName
      WritePrivateProfileString "All", "PenWidth",Str$(PenWidth), INIFileName
      WritePrivateProfileString "All", "DrawWidth",Str$(DrawWidth), INIFileName
      WritePrivateProfileString "All", "EraseWidth",Str$(EraseWidth), INIFileName
      WritePrivateProfileString "All", "SpoutType",Str$(SpoutType), INIFileName
      WritePrivateProfileString "All", "SpoutCloud",Str$(SpoutCloud), INIFileName
      WritePrivateProfileString "All", "HalfSize",Str$(HalfSize), INIFileName
      WritePrivateProfileString "All", "BSelection",Str$(BSelection), INIFileName
      WritePrivateProfileString "All", "CSelection",Str$(CSelection), INIFileName
      WritePrivateProfileString "All", "StartEmpty",Str$(StartEmpty), INIFileName
      WritePrivateProfileString "All", "ImportSize",Str$(ImportSize), INIFileName
      WritePrivateProfileString "All", "AllowMixing",Str$(AllowMixing), INIFileName
      WritePrivateProfileString "All", "FullCount",Str$(FullCount), INIFileName

      WritePrivateProfileString "All", "SandColor",Str$(SandColor), INIFileName
      WritePrivateProfileString "All", "OilColor",Str$(OilColor), INIFileName
      WritePrivateProfileString "All", "WaterColor",Str$(WaterColor), INIFileName
      WritePrivateProfileString "All", "SeedColor",Str$(SeedColor), INIFileName
      WritePrivateProfileString "All", "FireColor",Str$(FireColor), INIFileName
      WritePrivateProfileString "All", "SaltColor",Str$(SaltColor), INIFileName
      WritePrivateProfileString "All", "LaserColor",Str$(LaserColor), INIFileName
      WritePrivateProfileString "All", "CloudColor",Str$(CloudColor), INIFileName
      WritePrivateProfileString "All", "VirusColor",Str$(VirusColor), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), temp, INIFileName
      Next

   End If
End Sub

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(11)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1 : ac(cc).cmd  = %IDT_Help            : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_C  : ac(cc).cmd  = %IDM_Capture         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_D  : ac(cc).cmd  = %IDM_FullCount       : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_E  : ac(cc).cmd  = %IDM_BigErase        : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_I  : ac(cc).cmd  = %IDM_Information     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_M  : ac(cc).cmd  = %IDM_AllowMixing     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N  : ac(cc).cmd  = %IDM_ImportSize100   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_P  : ac(cc).cmd  = %IDT_Play            : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_R  : ac(cc).cmd  = %IDT_Restart         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S  : ac(cc).cmd  = %IDM_RemoveMRStream  : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T  : ac(cc).cmd  = %IDM_Test            : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_Z  : ac(cc).cmd  = %IDM_Debug           : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateToolbarStructures
    If Debug Then Txt.Print FuncName$
    ImageList New Icon 24,24,24,40 To hImageList
    ImageList Add Icon hImageList, "xhelp"     '1
    ImageList Add Icon hImageList, "xsettings" '2
    ImageList Add Icon hImageList, "xdraw"     '3
    ImageList Add Icon hImageList, "xerase"    '4
    ImageList Add Icon hImageList, "xsound"    '5
    ImageList Add Icon hImageList, "xbarriers" '6
    ImageList Add Icon hImageList, "xcompact"  '7
    ImageList Add Icon hImageList, "xxprint"   '8
    ImageList Add Icon hImageList, "xrestart"  '9
    ImageList Add Icon hImageList, "xplay"     '10
    ImageList Add Icon hImageList, "xplus"     '11
    ImageList Add Icon hImageList, "xminus"    '12
    ImageList Add Icon hImageList, "xspout"    '13
    ImageList Add Icon hImageList, "xcutb"     '14
    ImageList Add Icon hImageList, "xcutp"     '15
    ImageList Add Icon hImageList, "xopen"     '16
    ImageList Add Icon hImageList, "xsave"     '17
    ImageList Add Icon hImageList, "xfolder"   '18
    ImageList Add Icon hImageList, "xcut"      '19
    ImageList Add Icon hImageList, "ximage"    '20
    ImageList Add Icon hImageList, "xsand"     '21
    ImageList Add Icon hImageList, "xoil"      '22
    ImageList Add Icon hImageList, "xwater"    '23
    ImageList Add Icon hImageList, "xseed"     '24
    ImageList Add Icon hImageList, "xfire"     '25
    ImageList Add Icon hImageList, "xsalt"     '26
    ImageList Add Icon hImageList, "xlaser"    '27
    ImageList Add Icon hImageList, "xcloud"    '28
    ImageList Add Icon hImageList, "xvirus"    '29
    ImageList Add Icon hImageList, "xselect"   '30
    ImageList Add Icon hImageList, "xcuti"     '31
    ImageList Add Icon hImageList, "xzoom"     '32

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Show Status in Caption", %IDM_ShowStatus, %MF_Enabled
    Menu Add String, hSettings, "-",0,0
'    Menu Add String, hSettings, "Select Font", %IDM_Font, %MF_Enabled
    Menu Add String, hSettings, "Select BackGround Color", %IDM_Color, %MF_Enabled
    Menu Add String, hSettings, "Edit Draw Width", %IDM_DrawWidth, %MF_Enabled
    Menu Add String, hSettings, "Edit Erase Width", %IDM_EraseWidth, %MF_Enabled
    Menu Add String, hSettings, "Edit Maximum Particle Count", %IDM_PMax, %MF_Enabled
    Menu Add String, hSettings, "Edit Import Scale Factor", %IDM_ImportScaleFactor, %MF_Enabled
    Menu Add String, hSettings, "-",0,0
    Menu Add String, hSettings, "Custom Cursors", %IDM_CustomCursors, %MF_Enabled
    Menu Add String, hSettings, "Auto Save Session", %IDM_AutoSave, %MF_Enabled
    Menu Add String, hSettings, "Allow Mixing", %IDM_AllowMixing, %MF_Enabled
    Menu Add String, hSettings, "Full Count Caption", %IDM_FullCount, %MF_Enabled
    Menu Add String, hSettings, "Ask For Confirmation", %IDM_AskConfirmation, %MF_Enabled
    Menu Add String, hSettings, "Landscape Printing", %IDM_Landscape, %MF_Enabled
    Menu Add String, hSettings, "Spout Cloud", %IDM_SpoutCloud, %MF_Enabled
    Menu Add String, hSettings, "Start Game Empty", %IDM_StartEmpty, %MF_Enabled
End Sub

Sub CreateToolbarB
   If Debug Then Txt.Print FuncName$
    Control Add Toolbar, hDlg, %IDC_ToolbarB,"", 0,60,0,0, %CCS_NoMoveY Or %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_ToolbarB To hToolbarB
    SendMessage hToolbarB, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_ToolbarB, hImageList, 0

    Toolbar Add Button  hDlg, %IDC_ToolbarB, 30, %IDT_Select,  %BTNS_CheckGroup, "Select"

'    Toolbar Add Button  hDlg, %IDC_ToolbarB, 0, %IDT_SepA,  %BTNS_CheckGroup, ""
'    Toolbar Set State hDlg, %IDC_ToolbarB, 2,%TBState_Disabled

    Toolbar Add Button  hDlg, %IDC_ToolbarB, 6, %IDT_DrawBarrier,  %BTNS_CheckGroup, "Barrier"

'    Toolbar Add Button  hDlg, %IDC_ToolbarB, 0, %IDT_SepA,  %BTNS_CheckGroup, ""
'    Toolbar Set State hDlg, %IDC_ToolbarB, 4,%TBState_Disabled

    Toolbar Add Button  hDlg, %IDC_ToolbarB, 19, %IDT_CutAll,  %BTNS_CheckGroup, "All"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 14, %IDT_CutBarriers,  %BTNS_CheckGroup, "Barriers"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 15, %IDT_CutParticles,  %BTNS_CheckGroup, "Particles"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 31, %IDT_CutImports,  %BTNS_CheckGroup, "Imports"

'    Toolbar Add Button  hDlg, %IDC_ToolbarB, 0, %IDT_SepA,  %BTNS_CheckGroup, ""
'    Toolbar Set State hDlg, %IDC_ToolbarB, 9,%TBState_Disabled

    Toolbar Add Button  hDlg, %IDC_ToolbarB, 21, %IDT_Sand,  %BTNS_CheckGroup, "Sand"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 22, %IDT_Oil,  %BTNS_CheckGroup, "Oil"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 23, %IDT_Water,  %BTNS_CheckGroup, "Water"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 24, %IDT_Seed,  %BTNS_CheckGroup, "Seed"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 25, %IDT_Fire,  %BTNS_CheckGroup, "Fire"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 26, %IDT_Salt,  %BTNS_CheckGroup, "Salt"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 27, %IDT_Laser,  %BTNS_CheckGroup, "Laser"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 28, %IDT_Cloud,  %BTNS_CheckGroup, "Cloud"
    Toolbar Add Button  hDlg, %IDC_ToolbarB, 29, %IDT_Virus,  %BTNS_CheckGroup, "Virus"
'    Toolbar Add Separator hDlg, %IDC_ToolbarB, 5
End Sub

Sub CreateToolbarC
    If Debug Then Txt.Print FuncName$
    Local temp$, i As Long

    BMax = 0
    ImageList New Icon 24,24,32,100 To hImageListC
    temp$ = Dir$("images\*.*")
    While Len(temp$)
       Incr BMax
       ReDim Preserve ImportText(BMax)
       ImportText(BMax) = Exe.Path$ + "images\" + temp$
       ImageList Add Icon hImageListC, GdiPlusCreateHICONFromFile(ImportText(BMax))
       temp$ = Dir$
    Wend

    Control Add Toolbar, hDlg, %IDC_ToolbarC,"", 0,120,BW*BMax,40, %TbStyle_Flat Or %CCS_NoResize
    Control Handle hDlg, %IDC_ToolbarC To hToolbarC
    SendMessage hToolbarC, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    For i = 1 To BMax
       Toolbar Add Button  hDlg, %IDC_ToolbarC, i, %IDT_ButtonC+i, %BTNS_CheckGroup, ""
    Next i

    Toolbar Set ImageList hDlg, %IDC_ToolbarC, hImageListC, 0
End Sub

Sub CreateToolbar
    If Debug Then Txt.Print FuncName$
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_OpenGame,  %BTNS_Button + %BTNS_DropDown, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDT_SaveGame,  %BTNS_Button, "SaveAs"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Play,  %BTNS_Check, "Play"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Restart,  %BTNS_Button, "ReStart"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Plus,  %BTNS_Button, "Faster"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Minus,  %BTNS_Button, "Slower"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 32, %IDT_Zoom,  %BTNS_Button, Str$(ImportSize) + "%"

    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Sound,  %BTNS_Check, "Sounds"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Print,  %BTNS_Button Or %BTNS_DropDown, "Print"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Help,  %BTNS_Button Or %BTNS_DropDown, "Help"
    Control Set Font hDlg, %IDC_Toolbar, hFont
End Sub

Sub CreateContextMenus
    If Debug Then Txt.Print FuncName$
    Menu New PopUp To hContext
    Menu Add String, hContext, "Zoom at Cursor",  %IDM_Zoom,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Remove All Particles",  %IDM_RemoveAllParticles,  %MF_Enabled
    Menu Add String, hContext, "Compact Particle List",  %IDM_Compact,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Add Default Barriers",  %IDM_AddDefaultBarriers,  %MF_Enabled
    Menu Add String, hContext, "Remove All Barriers",  %IDM_RemoveAllBarriers,  %MF_Enabled
'    Menu Add String, hContext, "Remove Most Recent Barrier",  %IDM_RemoveMRBarrier,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Add Default Streams",  %IDM_AddDefaultstreams,  %MF_Enabled
    Menu Add String, hContext, "Remove All Streams",  %IDM_RemoveAllStreams,  %MF_Enabled
    Menu Add String, hContext, "Remove Most Recent Stream",  %IDM_RemoveMRStream,  %MF_Enabled

    Menu New PopUp To hHelp
    Menu Add String, hHelp, "Local Help",  %IDM_LocalHelp,  %MF_Enabled
    Menu Add String, hHelp, "Online Update",  %IDM_OnlineUpdate,  %MF_Enabled

    Menu New PopUp To hPrint
    Menu Add String, hPrint, "Capture",  %IDM_Capture,  %MF_Enabled

    Menu New PopUp To hSelect
    Menu Add String, hSelect, "Cancel",  %IDM_SCancel,  %MF_Enabled
    Menu Add String, hSelect, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hSelect, "Erase All",  %IDM_SEraseAll,  %MF_Enabled
    Menu Add String, hSelect, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hSelect, "Erase Barriers",  %IDM_SEraseBarriers,  %MF_Enabled
    Menu Add String, hSelect, "Erase Particles",  %IDM_SEraseParticles,  %MF_Enabled
    Menu Add String, hSelect, "Erase Imports",  %IDM_SEraseImports,  %MF_Enabled
    Menu Add String, hSelect, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hSelect, "Copy",  %IDM_SCopy,  %MF_Enabled

End Sub

Sub CreateGameMenu
   If Debug Then Txt.Print FuncName$
   Local iCount As Long, temp$
   Menu New PopUp To hGames
   temp$ = Dir$("games\*.gam")
   While Len(temp$)
      Incr iCount
      Menu Add String, hGames, PathName$(Name,temp$), %IDM_GameMenu+iCount,  %MF_Enabled
      temp$ = Dir$
   Wend
   If iCount = 0 Then Menu Add String, hGames, "No game files found!", %IDM_GameMenu,  %MF_Enabled
End Sub

Sub SetMenusAndToolbar
   If Debug Then Txt.Print FuncName$
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Play, PlayGame * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Sound, PlaySounds * %TBState_Checked Or %TBState_Enabled
    If BSelection > 0 Then
        Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd BSelection, %TBState_Enabled Or %TBState_Checked
        Toolbar Set State hDlg, %IDC_ToolbarC, ByCmd Abs(CSelection), %TBState_Enabled
    Else
        Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd Abs(BSelection), %TBState_Enabled
        Toolbar Set State hDlg, %IDC_ToolbarC, ByCmd CSelection, %TBState_Enabled Or %TBState_Checked
    End If

   'Menus
    Menu Set State hSettings, ByCmd %IDM_ShowStatus, ShowStatus * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_CustomCursors, CustomCursors * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoSave, AutoSave * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AllowMixing, AllowMixing * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_FullCount, FullCount * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AskConfirmation, AskConfirmation * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_Landscape, Landscape * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SpoutCloud, SpoutCloud * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_StartEmpty, StartEmpty * %MFS_Checked Or %MFS_Enabled

End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_OpenGame     : Function = "Open Existing Game File"
      Case %IDT_SaveGame     : Function = "Save Current Game to File"
      Case %IDT_Play         : Function = "Play Game"
      Case %IDT_Restart      : Function = "Start Game Over"
      Case %IDT_Minus        : Function = "Slow Game Down"
      Case %IDT_Plus         : Function = "Speed Game Up"
      Case %IDT_Zoom         : Function = "Import Scale Factor"
      Case %IDT_Sound        : Function = "Play Sounds"
      Case %IDT_Print        : Function = "Print Game"
      Case %IDT_Settings     : Function = "Default Settings Button Action"
      Case %IDT_Help         : Function = "Open Online Help"

      Case %IDT_Select       : Function = "Select Area of Game"
      Case %IDT_DrawBarrier  : Function = "Draw Barrier With Mouse"
      Case %IDT_CutAll       : Function = "Cut All Screen Items"
      Case %IDT_CutBarriers  : Function = "Cut Hand-Drawn Barriers Only"
      Case %IDT_CutParticles : Function = "Cut Particles Only"
      Case %IDT_CutImports   : Function = "Cut Imported Barriers Only"
      Case %IDT_Sand         : Function = "Create Sand Spout"
      Case %IDT_Oil          : Function = "Create Oil Spout"
      Case %IDT_Water        : Function = "Create Water Spout"
      Case %IDT_Seed         : Function = "Create Seed Spout"
      Case %IDT_Fire         : Function = "Create Fire Spout"
      Case %IDT_Salt         : Function = "Create Salt Spout"
      Case %IDT_Laser        : Function = "Create Laser Spout"
      Case %IDT_Cloud        : Function = "Create Cloud Spout"
      Case %IDT_Virus        : Function = "Create Virus Spout"
   End Select
End Function

Sub SelectMainFont
   If Debug Then Txt.Print FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
   UnhookWindowsHookEx ghHook
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then Txt.Print FuncName$
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub ZoomAtMouse
   If Debug Then Txt.Print FuncName$
   Local hWin As Dword, x,y As Long, pt As Point
   Dialog Get Loc hDlg To x,y
   Graphic Window New "Zoom", x+100,y+100,400,400 To hWin
   Dialog Set Icon hWin, "xzoom"
   pt = PTMenu
   ScreenToClient hDlg, pt
   Graphic Attach hWin,0
   Graphic Stretch hDlg,%IDC_Graphic, (pt.x-50,pt.y-50-TBM)-(pt.x+50,pt.y+50-TBM) To (0,0)-(400,400)
   Graphic Attach hDlg, %IDC_Graphic
   Graphic Width PenWidth
End Sub

Sub CompactParticles
   If Debug Then Txt.Print FuncName$
   Local i,iCount,iPlay As Long
   iPlay = PlayGame
   PlayGame = 0
   pCount = Min(pCount,UBound(P))
   For i = 1 To pCount
      If P(i).x > 0 Then
         'is non-dead particle
         P(iCount) = P(i)
         Incr iCount
         C(P(i).x,P(i).y) = P(i).bgrcolor
         PF(P(i).x,P(i).y) = i
      End If
   Next i
   pCount = iCount-1
   PlayGame = iPlay
End Sub

Sub RemoveAllParticles
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h,iPlay As Long
   iPlay = PlayGame
   PlayGame = 0
   pCount = 0
   Control Get Size hDlg, %IDC_Graphic To w,h
   For x = 0 To w-1
      For y = 0 To h-1
         If PF(x,y) > 0 Then
            C(x,y) = BGRBGColor
            P(PF(x,y)).x = %IsDeadParticle
            PF(x,y) = %IsEmptyCell
         End If
      Next y
   Next x
   PlayGame = iPlay
End Sub

Sub RemoveMRBarrier
   If Debug Then Txt.Print FuncName$
   Local i As Long
   i = UBound(Barriers)
   If i = 0 Then Exit Sub
   ReDim Preserve Barriers(i-1)
End Sub

Sub RemoveAllBarriers(Flag As Long)
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h As Long
   If Flag Then ReDim Barriers(0)
   Control Get Size hDlg, %IDC_Graphic To w,h
   For x = 0 To w-1
      For y = 0 To h-1
         If PF(x,y) = %IsBarrierCell Then
            PF(x,y) = %IsEmptyCell
            C(x,y) = BGRBGColor
         End If
      Next y
   Next x
End Sub

Sub RemoveAllStreams
   ReDim Streams(0)
End Sub

Sub RemoveMRStream
   If Debug Then Txt.Print FuncName$
   Local i As Long
   i = UBound(Streams)
   If i Then ReDim Preserve Streams(i-1)
End Sub

Sub RestartGame
   If Debug Then Txt.Print FuncName$
   If IsFile($SessionFile) Then Kill $SessionFile
   Graphic Clear BGColor
   Graphic ReDraw
   pCount = 0
   ClearScreen
   QueryPerformanceCounter qGameStart
   If StartEmpty = 0 Then AddDefaultBarriers : AddDefaultStreams : DisplayAllBarriers
End Sub

Sub LoadGame(fName$)
   If Debug Then Txt.Print FuncName$
   Local bCount,sCount,sw,sh As Long
   If IsFalse(IsFile(fName$)) Then Exit Sub

   Open fName$ For Binary As #1
      'variables
      Get #1,, pMax       'UBound(P)
      Get #1,, pCount    'particle cound when game saved
      Get #1,, sw        'screen size of the game when last played
      Get #1,, sh        'screen size of the game when last played
      Get #1,, bcount    'UBound(Barriers)
      Get #1,, scount    'UBound(Streams)

      'arrays
      'barriers
      ReDim Barriers(bCount)
      Get #1,, Barriers()
      'streams
      ReDim Streams(sCount)
      Get #1,, Streams()
      'points
      ReDim P(pCount)
      Get #1,, P()
      ReDim Preserve P(PMax)
      'colors
      ReDim C(sw-1,sh-1) At StrPtr(bmp$)+8
      Get #1,, C()
      'point finder
      ReDim PF(sw-1,sh-1)
      Get #1,, PF()
   Close #1
End Sub

Sub SaveGame(fName$)
   If Debug Then Txt.Print FuncName$
   Local sw,sh,i As Long
   sw = GetSystemMetrics(%SM_CXVirtualScreen)
   sh = GetSystemMetrics( %SM_CYVirtualScreen)
   Open fName$ For Binary As #1
      'variables
      Put #1,,pMax
      Put #1,,pCount
      Put #1,,sw
      Put #1,,sh
      i = UBound(Barriers) : Put #1,,i
      i = UBound(Streams)  : Put #1,,i
'      Put #1,, bmp$
      'bitstring/arrays
      Put #1,, Barriers()
      Put #1,, Streams()
      ReDim Preserve P(pCount)
      Put #1,, P()
      Put #1,, C()
      Put #1,, PF()
   Close #1
End Sub

Sub AddDefaultBarriers
   If Debug Then Txt.Print FuncName$
   If UBound(Barriers) >=4 Then Exit Sub
   Local i,w,h As Long
   Dialog Get Client hDlg To w,h
   i = UBound(Barriers)
   ReDim Preserve Barriers(i+4)

   Barriers(i+1).x1 = w/5-20   : Barriers(i+1).x2 = w/5+20
   Barriers(i+1).y1 = h/5      : Barriers(i+1).y2 = h/5+10

   Barriers(i+2).x1 = 2*w/5-20 : Barriers(i+2).x2 = 2*w/5+20
   Barriers(i+2).y1 = 2*h/5    : Barriers(i+2).y2 = 2*h/5 + 10

   Barriers(i+3).x1 = 3*w/5-10 : Barriers(i+3).x2 = 3*w/5+30
   Barriers(i+3).y1 = h/2      : Barriers(i+3).y2 = h/2+10

   Barriers(i+4).x1 = 4*w/5-15 : Barriers(i+4).x2 = 4*w/5+30
   Barriers(i+4).y1 = h/3      : Barriers(i+4).y2 = h/3+10

End Sub

Sub AddDefaultStreams
   If Debug Then Txt.Print FuncName$
   If UBound(Streams) >=4 Then Exit Sub
   Local i,w,h As Long
   Dialog Get Client hDlg To w,h
   i = UBound(Streams)
   ReDim Preserve Streams(i+4)
   Streams(i+1).x1 = w/5   : Streams(i+1).x2 = w/5+6   : Streams(i+1).type = %Sand  : Streams(i+1).bgrcolor = BGRSandColor
   Streams(i+2).x1 = 2*w/5 : Streams(i+2).x2 = 2*w/5+6 : Streams(i+2).type = %Oil   : Streams(i+2).bgrcolor = BGROilColor
   Streams(i+3).x1 = 3*w/5 : Streams(i+3).x2 = 3*w/5+6 : Streams(i+3).type = %Water : Streams(i+3).bgrcolor = BGRWaterColor
   Streams(i+4).x1 = 4*w/5 : Streams(i+4).x2 = 4*w/5+6 : Streams(i+4).type = %Seed  : Streams(i+4).bgrcolor = BGRSeedColor
End Sub

Sub CreateSubFolders
   If Debug Then Txt.Print FuncName$
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "games") = %False Then MkDir Exe.Path$ + "games"
End Sub

Sub DrawPath(ByVal x0 As Long, ByVal y0 As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal W As Long, clr As Long)
   If Debug Then Txt.Print FuncName$
   Local i,iMin,iMax As Long
   DrawLine x0,y0,x1,y1, clr   '<--- C() needs BGR colors
   iMax = W\2
   iMin = iMax - W
   For i = iMin-1 To iMax+1 : DrawLine x0,y0-i,x1,y1-i, clr : Next i
End Sub

Sub DrawLine(ByVal x0 As Long, ByVal y0 As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal clr As Long)
'   If Debug Then Txt.Print FuncName$  '<---- diabled by choice
   Local e,e2,x,dx,dy,sx,sy As Long
   dx = Abs(x1-x0)
   dy = Abs(y1-y0)
   If x0 < x1 Then sx=1 Else sx=-1
   If y0 < y1 Then sy=1 Else sy=-1
   e = dx-dy

   Do

     If x0 <= 0 Or y0 <= 0 Then Iterate Loop
     If PF(x0,y0) > 0 Then P(PF(x0,y0)).x = %IsDeadParticle    'destroy any particles in the area that will be turned into a barrier
     PF(x0,y0) = %IsBarrierCell
     C(x0,y0) = clr

     If x0 = x1 And y0 = y1 Then Exit Loop
     e2 = 2*e
     If e2 > -dy Then
       e = e - dy
       x0 = x0 + sx
     End If
     If e2 <  dx Then
       e = e + dx
       y0 = y0 + sy
     End If
   Loop
End Sub

Sub DisplayLocalHelp
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = "gbSand " + $ver + $CrLf
   temp$ = temp$ + $CrLf + "Direct particle flow by drawing barriers in particle paths"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "After setting mouse mode on toolbar:"
   temp$ = temp$ + $CrLf + "     Draw barriers by dragging the left mouse"
   temp$ = temp$ + $CrLf + "     Erase particles or barriers by dragging the left mouse"
   temp$ = temp$ + $CrLf + "     Create particle spouts by double-clicking the left mouse"
   temp$ = temp$ + $CrLf + "     Import images by double-clicking the left mouse"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "Use context menu to modify streams, barriers and particles"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "Ctl-P toggles Pause"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "Restart erases all user drawn barriers, all particles, and all imported images"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "Sessions can be saved and restored the next time gbSand is started"
   temp$ = temp$ + $CrLf + ""
   temp$ = temp$ + $CrLf + "Enjoy!"
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox(0, (temp$), "Local Help", %MB_Ok + %MB_IconInformation)
   UnhookWindowsHookEx ghHook
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub LoadCursors
   If Debug Then Txt.Print FuncName$
   LoadOneCursor hCutAll, "xcurerase"
   LoadOneCursor hDrawBarriers, "xcurdraw"
   LoadOneCursor hCutBarriers, "xcurerase"
   LoadOneCursor hCutParticles, "xcurerase"
   LoadOneCursor hCursorSpout, "xcurspout"
   LoadOneCursor hCursorImage, "xcurimage"
   LoadOneCursor hCursorSelect, "xcurselect"
End Sub

Sub LoadOneCursor(hCur As Dword, curName$)
   If Debug Then Txt.Print FuncName$
   Local CurData$
   CurData$ = Resource$(RcData, curName$)
   Open $tempCursorFile For Binary As #1
   Put #1, ,Abs CurData$
   SetEof #1
   Close #1
   hCur = LoadCursorFromFile ($tempCursorFile)
   If IsFile($tempCursorFile) Then Kill $tempCursorFile
End Sub


Sub LoadImageToMemoryBitmap (ImgName As String, hWin As Dword, w As Long, h As Long, SF As Single)
   If Debug Then Txt.Print FuncName$
   Local pGraphics,pImage,hDC,token As Dword, StartupInput As GdiplusStartupInput

   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,w)                        'get width
   GdipGetImageHeight(pImage, h)                      'get height

   w = SF * w : h = SF * h

   Graphic Bitmap New w,h To hWin
   Graphic Attach hWin, 0
   Graphic Get DC To hDC

   GdipCreateFromHDC(hDC, pGraphics)                      ' Create the Graphic object
   GdipDrawImageRect(pGraphics, pImage, 0, 0, w, h) ' Draw the image

   'shutdown GDI
   If pImage Then GdipDisposeImage(pImage)            'cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   GdiplusShutdown token                              'shutdown GDI+
End Sub

Sub ImportImage(ByVal fName$, x0 As Long, y0 As Long)
   If Debug Then Txt.Print FuncName$
   Local hBits As String,x,y,w,h,xnew,ynew As Long
   LoadImagetoMemoryBitmap fName$, hBMP, w,h, ImportSize/100
   If w=0 Or h = 0 Then
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox(0, "Invalid image. One or both image dimensions is zero!", "Import Image", %MB_Ok + %MB_IconExclamation)
      UnhookWindowsHookEx ghHook
      Exit Sub
   End If
   Graphic Attach hBMP,0
   Graphic Get Bits To hBits
   ReDim D(w-1,h-1) As Long At StrPtr(hBits)+8
   Graphic Attach hDlg, %IDC_Graphic
   For x = 0 To w-1
      For y = 0 To h-1
         If D(x,y)<>0 Then
            xNew = Max(0,x+x0-w/2) : yNew = Max(0,y+y0-TBM-w/2)
            C(xnew,ynew) = D(x,y)
            If PF(xnew,ynew) > 0 Then P(PF(xnew,ynew)).x = %IsDeadParticle
            PF(xnew,ynew) = %IsImportCell  '>-1= live particle -1=dead particle, -2=barrier, -3=import, -4=empty
         End If
      Next i
   Next x
   Graphic ReDraw
End Sub

Sub CutOrDraw(x As Long, y As Long, wParam As Long)
   If Debug Then Txt.Print FuncName$
   Local i,j As Long
   If LastX = -1 Then LastX = x : LastY = y
   If (Lo(Word,wParam) And %MK_Control) = %MK_Control Then y = LastY
   If (Lo(Word,wParam) And %MK_Shift) = %MK_Shift     Then x = LastX
   Select Case ActionMode
      Case %Cut
         Select Case CutType
            Case %CutAll
               If PlaySounds Then PlaySound "xwaverasea", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
               'erase anything
               For i = x-PenWidth/2 To x+PenWidth/2
                  For j = y-PenWidth/2-TBM To y+PenWidth/2-TBM
                     If i <= 0 Or j <= 0 Then Iterate For
                     If PF(i,j) > 0 Then P(PF(i,j)).x = %IsDeadParticle
                     PF(i,j) = %IsEmptyCell 'empty cell
                     C(i,j) = BGRBGColor
                  Next j
               Next i
            Case %CutParticles
               If PlaySounds Then PlaySound "xwaverasep", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
               'erase particles
               For i = x-PenWidth/2 To x+PenWidth/2
                  For j = y-PenWidth/2-TBM To y+PenWidth/2-TBM
                     If i <= 0 Or j <= 0 Then Iterate For
                     If PF(i,j) > 0  Then 'is a live particle
                        P(PF(i,j)).x = %IsDeadParticle  '-1 means not a particle or dead particle
                        PF(i,j) = %IsEmptyCell       'empty cell
                        C(i,j) = BGRBGColor
                     End If
                  Next j
               Next i
            Case %CutBarriers
               If PlaySounds Then PlaySound "xwaveraseb", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
               'erase barriers
               For i = x-PenWidth/2 To x+PenWidth/2
                  For j = y-PenWidth/2-TBM To y+PenWidth/2-TBM
                     If i <= 0 Or j <= 0 Then Iterate For
                     If PF(i,j) = %IsBarrierCell Then 'is a barrier
                        C(i,j) = BGRBGColor
                        PF(i,j) = %IsEmptyCell        'empty cell
                     End If
                  Next j
               Next i
            Case %CutImports
               If PlaySounds Then PlaySound "xwaverasei", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
               'erase barriers
               For i = x-PenWidth/2 To x+PenWidth/2
                  For j = y-PenWidth/2-TBM To y+PenWidth/2-TBM
                     If i <= 0 Or j <= 0 Then Iterate For
                     If PF(i,j) = %IsImportCell Then 'is an import
                        C(i,j) = BGRBGColor
                        PF(i,j) = %IsEmptyCell        'empty cell
                     End If
                  Next j
               Next i
         End Select
      Case %Draw
         If PlaySounds Then PlaySound "xwavdraw", GetModuleHandle(ByVal 0), %SND_Resource Or %SND_Async Or %SND_NoStop
         'write barriers
         DrawPath LastX, LastY-TBM, x, y-TBM, PenWidth, BGRBarrierColor
         LastX = x : LastY = y
   End Select
End Sub

Function InputBoxProcExt(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 310                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 290 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 405 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub BuildSpoutColors
   If Debug Then Txt.Print FuncName$
   BGRSandColor  = Bgr(SandColor)
   BGROilColor   = Bgr(OilColor)
   BGRWaterColor = Bgr(WaterColor)
   BGRSeedColor  = Bgr(SeedColor)
   BGRFireColor  = Bgr(FireColor)
   BGRSaltColor  = Bgr(SaltColor)
   BGRLaserColor  = Bgr(LaserColor)
   BGRCloudColor  = Bgr(CloudColor)
   BGRVirusColor  = Bgr(VirusColor)

   ReDim SpoutColors(8)
   SpoutColors(0) = BGRSandColor
   SpoutColors(1) = BGROilColor
   SpoutColors(2) = BGRWaterColor
   SpoutColors(3) = BGRSeedColor
   SpoutColors(4) = BGRFireColor
   SpoutColors(5) = BGRSaltColor
   SpoutColors(6) = BGRLaserColor
   SpoutColors(7) = BGRCloudColor
   SpoutColors(8) = BGRVirusColor

   ReDim SpoutText(8)
   SpoutText(0) = "Sand  "
   SpoutText(1) = "   Oil   "
   SpoutText(2) = "Water"
   SpoutText(3) = "Seed  "
   SpoutText(4) = "Fire    "
   SpoutText(5) = "Salt    "
   SpoutText(6) = "Laser   "
   SpoutText(7) = "Cloud   "
   SpoutText(8) = "Virus    "
End Sub

Sub SaveAsGame
   If Debug Then Txt.Print FuncName$
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""                'caption title. if "", then "Save As" is displayed
    startfolder$ = Exe.Path$ + "games"    'initial folder to be displayed
    filter$ = "gbSand Game Files" + $Nul + "*.gam" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = FileName      'name to be used as initial selection
    defaultext$ = "txt"        'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then FileName = filevar$ : SaveGame((FileName))
End Sub

Sub SelectAndLoadGame
    If Debug Then Txt.Print FuncName$
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "gbSand Game Files" + $Nul + "*.gam" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then FileName = filevar$ : LoadGame((FileName))
End Sub

Sub ClearScreen
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h As Long
   Control Get Size hDlg, %IDC_Graphic To w,h

   ReDim Barriers(0)
   ReDim Streams(0)
   ReDim P(PMax)
   ReDim C(w-1,h-1) At StrPtr(bmp$)+8
   ReDim PF(w-1,h-1)

   'Set all colors elements to BGR of BGcolor
   For x = 0 To w-1
      For y = 0 To h-1
         C(x,y) = BGRBGColor
         PF(x,y) = %IsEmptyCell
      Next y
   Next x
End Sub

Sub PrintGame
   If Debug Then Txt.Print FuncName$
   Local x,y,wNew,hNew,wImg,hImg,wCont,hCont,iResult As Long
   Local hDC_Dialog, hBMP_Dialog, hDC_Graphic As Dword

   iResult = PlayGame
   PlayGame = 0

   XPrint Attach Choose
   If Len(XPrint$)=0 Then Exit Sub
   XPrint Set Orientation IIf(Landscape,2,1)

   Dialog Get Size hDlg To wImg,hImg
   hDC_Dialog = GetWindowDC (hDlg)
   Graphic Bitmap New wImg,hImg To hBMP_Dialog
   Graphic Attach hBMP_Dialog, 0
   Graphic Get DC To hDC_Graphic
   BitBlt hDC_Graphic, 0,0,wImg,hImg, hDC_Dialog, 0,0, %SRCCopy
   ReleaseDC hDlg, hDC_Dialog  'PowerBASIC handles release of hDC_Graphic

   XPrint Get Client To wCont, hCont

   'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
   wNew = wImg / Max(wImg / wCont, hImg / hCont)
   hNew = hImg / Max(wImg / wCont, hImg / hCont)
   x = (wCont-wNew)/2 : y = (hCont-hNew)/2               'upper/left position so resized image is centered
   XPrint Stretch hBMP_Dialog, 0, (0,0)-(wImg-1,hImg-1) To (x,y)-(x+wNew-1,y+hNew-1)  'copy (resized) from memory bitmap to visible image
   XPrint Close

   PlayGame = iResult
End Sub

Sub DrawRect(Flag As Long)   '1=moving 0=done
   If Debug Then Txt.Print FuncName$
   Local tempR As Rect
   Graphic Set Mix %Mix_NotXorSrc : Graphic Width 1 : Graphic Style 1
   Graphic Box (R2.nLeft,R2.nTop-TBM)-(R2.nRight,R2.nBottom-TBM), 0, %Red
   tempR.nLeft = Min(R.nLeft,R.nRight)
   tempR.nRight = Max(R.nLeft,R.nRight)
   tempR.nTop = Min(R.nTop,R.nBottom)
   tempR.nBottom = Max(R.nTop,R.nBottom)
   If Flag Then
      Graphic Box (tempR.nLeft,tempR.nTop-TBM)-(tempR.nRight,tempR.nBottom-TBM),0, %Red
      R2 = tempR
   Else
      Reset R2
   End If
   Graphic ReDraw
End Sub

Sub CopySelection
   If Debug Then Txt.Print FuncName$
   Local tempR As Rect, hClipBMP As Dword

   tempR.nLeft = Min(R.nLeft,R.nRight)
   tempR.nRight = Max(R.nLeft,R.nRight)
   tempR.nTop = Min(R.nTop,R.nBottom)
   tempR.nBottom = Max(R.nTop,R.nBottom)

   Graphic Bitmap New tempR.nRight-tempR.nLeft+1, tempR.nBottom-tempR.nTop+1 To hClipBMP
   Graphic Attach hClipBMP, 0

   Graphic Copy hDlg, %IDC_Graphic, (tempR.nLeft,tempR.nTop-TBM)-(tempR.nRight,tempR.nBottom-TBM) To (0,0)
   Clipboard Reset
   Clipboard Set Bitmap hClipBMP
   Graphic Attach hDlg, %IDC_Graphic
End Sub

Sub CutSelection
   If Debug Then Txt.Print FuncName$
   Local i,j As Long, tempR As Rect
   tempR.nLeft = Min(R.nLeft,R.nRight)
   tempR.nRight = Max(R.nLeft,R.nRight)
   tempR.nTop = Min(R.nTop,R.nBottom)
   tempR.nBottom = Max(R.nTop,R.nBottom)

   Select Case CutType
      Case %CutAll
         'erase anything
         For i = tempR.nLeft To tempR.nRight
            For j = tempR.Top-TBM To tempR.bottom-TBm
               If i <= 0 Or j <= 0 Then Iterate For
               If PF(i,j) > 0 Then P(PF(i,j)).x = %IsDeadParticle
               PF(i,j) = %IsEmptyCell
               C(i,j) = BGRBGColor
            Next j
         Next i
      Case %CutBarriers
         'erase barriers
         For i = tempR.nLeft To tempR.nRight
            For j = tempR.Top-TBM To tempR.bottom-TBm
               If i <= 0 Or j <= 0 Then Iterate For
               If PF(i,j) = %IsBarrierCell Then
                  PF(i,j) = %IsEmptyCell
                  C(i,j) = BGRBGColor
               End If
            Next j
         Next i
      Case %CutParticles
         'erase anything
         For i = tempR.nLeft To tempR.nRight
            For j = tempR.Top-TBM To tempR.bottom-TBm
               If i <= 0 Or j <= 0 Then Iterate For
               If PF(i,j) > 0 Then
                  P(PF(i,j)).x = %IsDeadParticle
                  PF(i,j) = %IsEmptyCell
                  C(i,j) = BGRBGColor
               End If
            Next j
         Next i
      Case %CutImports
         'erase anything
         For i = tempR.nLeft To tempR.nRight
            For j = tempR.Top-TBM To tempR.bottom-TBm
               If i <= 0 Or j <= 0 Then Iterate For
               If PF(i,j) = %IsImportCell Then
                  PF(i,j) = %IsEmptyCell
                  C(i,j) = BGRBGColor
               End If
            Next j
         Next i
   End Select
End Sub

Sub ReadText (sText As String)
   If Debug Then Txt.Print FuncName$
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub

Sub ReBuildZoom
   If Debug Then Txt.Print FuncName$
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Zoom
   Toolbar Add Button hDlg, %IDC_Toolbar, 32, %IDT_Zoom, %BTNS_Button, Str$(ImportSize) + "%" At 10
End Sub

Sub UpdateCaption
   If FullCount Then
      If ShowStatus Then Dialog Set Text hDlg, "Falling Sand v" + $ver + Space$(10) + _
         Format$(pCount,"#,###,##0") + " TotalP    " + _
         Format$(pLiveCount,"#,###,##0") + " LiveP    " + _
         Format$((qStop-qStart)/qFreq*1000,"#00.0") & " ms/Cycle    " + _
         Format$((qStop-qGameStart)/qFreq/60,"#,##0.0") & "m Game Time    " + _
         Format$(TimerInterval,"##0") & " ms Interval    " + _
         Format$(GameSpeed,"##0") & " Cycle/Interval"
   Else
      If ShowStatus Then Dialog Set Text hDlg, "Falling Sand v" + $ver + Space$(10) + _
         Format$(pCount/1000,"#,###,##0") + "K TotalP    " + _
         Format$(pLiveCount/1000,"#,###,##0") + "K LiveP    " + _
         Format$((qStop-qStart)/qFreq*1000,"#00.0") & " ms/Cycle    " + _
         Format$((qStop-qGameStart)/qFreq/60,"#,##0.0") & "m Game Time    " + _
         Format$(TimerInterval,"##0") & " ms Interval    " + _
         Format$(GameSpeed,"##0") & " Cycle/Interval"
   End If
End Sub

Sub MoveParticles
'   If Debug Then Txt.Print FuncName$  '<--- disabled by choice
   Local x,y,i,w,h,x1,y1 As Long
   Dialog Get Client hDlg To w,h
   'alternate between using lower Left and lower Right as second movement option
   Delta = -Delta   'Delta = -1 + Rnd(0,1)*2

   'move all particles which have an empty spot below/left/right of the particle
   pLiveCount = 0
   For i = 1 To pCount
      If P(i).x = %IsDeadParticle Then Iterate For
      Incr pLiveCount
      x = P(i).x : y = P(i).y
      If (y >= h-1-TBM) And IsFalse(IsIconic(hDlg)) Then 'remove particle because is at bottom
         'remove particle
         P(i).x          = %IsDeadParticle
         'update old cell
         C(x,y)          = BGRBGColor
         PF(x,y)         = %IsEmptyCell
      ElseIf PF(x,y+1)   = %IsEmptyCell Then             'move directly below
         'move particle
         P(i).y          = y+1
         'update old cell
         C(x,y)          = BGRBGColor
         PF(x,y)         = %IsEmptyCell
         'update new cell
         C(x,y+1)        = P(i).bgrcolor
         PF(x,y+1)       = i
      ElseIf PF(x-Delta,y) = %IsEmptyCell Then           'move left (when Delta = 1)
         'move particle
         P(i).x          = x-Delta
         P(i).y          = y
         'update old cell
         C(x,y)          = BGRBGColor
         PF(x,y)         = %IsEmptyCell
         'update new cell
         C(x-Delta,y)    = P(i).bgrcolor
         PF(x-Delta,y)   = i
      ElseIf PF(x+Delta,y) = %IsEmptyCell Then          'move right (when Delta = 1)
         'move particle
         P(i).x          = x+Delta
         P(i).y          = y
         'update old cell
         C(x,y)          = BGRBGColor
         PF(x,y)         = %IsEmptyCell
         'update new cell
         C(x+Delta,y)    = P(i).bgrcolor
         PF(x+Delta,y)   = i
      ElseIf PF(x-Delta,y+1) = %IsEmptyCell Then        'move down and left (when Delta = 1)
         'move particle
         P(i).x          = x-Delta
         P(i).y          = y+1
         'update old cell
         C(x,y)          = BGRBGColor
         PF(x,y)         = %IsEmptyCell
         'update new cell
         C(x-Delta,y+1)  = P(i).bgrcolor
         PF(x-Delta,y+1) = i
      ElseIf PF(x+Delta,y+1) = %IsEmptyCell Then        'move down and right (when Delta = 1)
         'move particle
         P(i).x          = x+Delta
         P(i).y          = y+1
         'update old cell
         C(x,y) = BGRBGColor
         PF(x,y)         = %IsEmptyCell
         'update new cell
         C(x+Delta,y+1)  = P(i).bgrcolor
         PF(x+Delta,y+1) = i
      Else   'randomly change places with an adjacent particle, any of 8 directions
         If AllowMixing Then
            Select Case Rnd(0,19)   'get x1,y1 position of random neighboring cell
               Case 0 To 1   : x1 = x+1 : y1 = y+1    'lower right
               Case 2 To 3   : x1 = x-1 : y1 = y+1    'lower left
               Case 4        : x1 = x   : y1 = y+1    'lower middle
               Case 5 To 9   : x1 = x+1 : y1 = y      'right
               Case 10 To 14 : x1 = x-1 : y1 = y      'left
               Case 15 To 16 : x1 = x-1 : y1 = y-1    'upper left
               Case 17       : x1 = x   : y1 = y-1    'upper middle
               Case 18 To 19 : x1 = x+1 : y1 = y-1    'upper right
            End Select
            'nothing off screen
            x1 = Max(0,x1) : y1 = Max(0,y1)
            x1 = Min(w,x1) : y1 = Min(h,y1)

            If PF(x1,y1) > 0 Then
              'swap with the random neighboring particle
               Swap P(i),P(PF(x1,y1))
               Swap C(x,y),C(x1,y1)
               Swap PF(x,y),PF(x1,y1)
            ElseIf (PF(x1,y1) = %IsEmptyCell) Then
              'swap with the random empty neighboring cell
               P(i).x = x1
               P(i).y = y1
               Swap C(x,y),C(x1,y1)
               Swap PF(x,y),PF(x1,y1)
            End If

         End If
      End If
   Next i
End Sub

Sub GetDebug
   Local temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   Getprivateprofilestring "All", "Debug", "0", temp, %Max_Path, INIFileName:  Debug = Val(temp)
End Sub
